package R;

/**
 * Provides constants and helper methods to use during R execution 
 * 
 * @author Robert Eisinger
 */
public class RConfig {
    
    //Names of R functions
    public static String powerModel = "mlm.powermodel";
    public static String linearModel = "mlm.linearmodel";
    public static String logModel = "mlm.logmodel";
    public static String discontinuousModel = "mlm.discontmodel";
    public static String countingModel = "mlm.countmodel";
    public static String AIC = "mlm.AIC";
    public static String LikelihoodRatio = "mlm.likelihoodratio";
    public static String wald = "mlm.waldtest";
    
    //R package location
    public static String packageLocation = null;
    
    /**
     * Given the name of an R model function (e.g., mlm.logmodel), return the 
     * colloquial name of that model (e.g., log)
     * @param model the model's function name
     * @return the model's colloquial name
     */
    public static String toColloquial(String model) {
        if(model.equals(powerModel)) {
            return "power";
        } else if(model.equals(linearModel)) {
            return "linear";
        } else if(model.equals(logModel)) {
            return "log";
        } else if(model.equals(discontinuousModel)) {
            return "discontinuous";
        } else if(model.equals(countingModel)) {
            return "counting";
        } 
        return model;
    }
    
}
