package calculatecv;

import java.awt.Font;
import java.io.File;
import javax.swing.ToolTipManager;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;


/**
 * The driver class that simply contains a main method where execution begins.
 * 
 * @author Robert Eisinger
 */
public class CalculateCV {

    /**
     * 
     * Launches the GUI after initializing the config
     * 
     * @param args the command line arguments
     * @throws java.lang.ClassNotFoundException
     * @throws java.lang.InstantiationException
     * @throws java.lang.IllegalAccessException
     * @throws javax.swing.UnsupportedLookAndFeelException
     */
    public static void main(String[] args) throws ClassNotFoundException, InstantiationException, IllegalAccessException, UnsupportedLookAndFeelException {

        System.setProperty("apple.laf.useScreenMenuBar", "true");
        System.setProperty(
            "com.apple.mrj.application.apple.menu.about.name", "Name");
        
        UIManager.put("ToolTip.font", new Font("Lucida Grande",Font.PLAIN,13));
        ToolTipManager.sharedInstance().setDismissDelay(Integer.MAX_VALUE);
        ToolTipManager.sharedInstance().setInitialDelay(1);
        
        Config.init();
        
        //String laf = UIManager.getSystemLookAndFeelClassName();
        //UIManager.setLookAndFeel(laf);
        
        System.setProperty("apple.laf.useScreenMenuBar", "true");
        System.setProperty(
            "com.apple.mrj.application.apple.menu.about.name", "Name");
        
        //UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
        
        new MainWindow();
        

    }
    
}
