/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package calculatecv;

import java.io.FileOutputStream;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

/**
 *
 * @author Robert
 */
public class Output {

    public static LinkedHashMap<String, OutputSheet> sheets = new LinkedHashMap<String, OutputSheet>();
    public static XSSFWorkbook workbook;
    public static DecimalFormat decimalFormat = new DecimalFormat("0.00000");

    public static void addToOutput(String sheetName, LinkedHashMap<String, ArrayList<String>> columns) {
        System.err.println("addToOutput: " + sheetName + ", " + columns.size());
        OutputSheet sheet = new OutputSheet(sheetName);
        if (sheets.containsKey(sheetName)) {
            sheet = sheets.get(sheetName);
        }

        sheet.addColumns(columns);
        sheets.put(sheetName,sheet);
    }
    
    
    public static void addToOutput(LinkedHashMap<String, LinkedHashMap<String, ArrayList<String>>> out) {
        
        Iterator<String> sheetNames = out.keySet().iterator();
        while(sheetNames.hasNext()) {
            String sheetName = sheetNames.next();
            System.err.println("SHEET NAME: " + sheetName);
            addToOutput(sheetName,out.get(sheetName));
        }
    }

    public static void save() {
        workbook = new XSSFWorkbook();

        Iterator<String> keys = sheets.keySet().iterator();
        int sheetNum = 0;
        while (keys.hasNext()) {
            String key = keys.next();

            System.err.println("save(): workbookSheet is " + key);
            Sheet workbookSheet = workbook.createSheet(key);
           
            OutputSheet sheet = sheets.get(key);
            LinkedHashMap<String, ArrayList<String>> columns = sheet.columns;

            Row headers = workbookSheet.createRow(0);
            Cell subj = headers.createCell(0);
            subj.setCellValue("subject");
            
            Iterator<String> columnKeys = columns.keySet().iterator();
            int columnNum = 0;
            while (columnKeys.hasNext()) {
                String columnKey = columnKeys.next();
                                
                Cell header = headers.createCell(columnNum);
                header.setCellValue(columnKey);
                ArrayList<String> column = columns.get(columnKey);
                for (int i = 0; i < column.size(); i++) {
                    Row row = workbookSheet.getRow(i+1);
                    if (row == null) {
                        row = workbookSheet.createRow(i+1);
                    }
                    

                    Cell cell = row.createCell(columnNum);
                    String val = column.get(i);
                    try {
                        double d = Double.parseDouble(val);
                        val = decimalFormat.format(d);
                        cell.setCellValue(Double.parseDouble(val));
                    } catch(Exception e) {
                         cell.setCellValue(val);
                    }
                    
                   
  
                }

                columnNum++;
            }

            sheetNum++;
        }

        try {
            FileOutputStream fileOut = new FileOutputStream(Config.step4Panel.getOutputPath());
            workbook.write(fileOut);
            fileOut.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
